%% Illustrasjon av antagelsen om at c=0.35
%% inndata
a=linspace(1000,3000,50);
fck=35;
p=linspace(0.005,0.03,500);
d=500;
b=250;
V=100;
q=100;
dg=16;
Es=200000;
Ec=10000*fck.^(1/3);
fy=500;
L=2.*a;
V_j=(q.*(L*10^-3))/2;
%% CSCT
fig=figure
subplot(1,2,1)
c_p=d.*p.*(Es./Ec).*((1+((2.*Ec)./(p.*Es))).^(1/2)-1);
c_test=0.35+(p-p);
cforhold_p=c_p./d;
plot(p,cforhold_p)
hold on
plot(p,c_test)
xlabel('p [-]')
ylabel('C/d [-]')
legend('Trykksonehyde','Antagelsen om at c=0.35d','location','northeast')
title('(a) Trykksonehyde ved varierende p','fontsize',16)
axis([ 0.005 0.03 0.2 0.5])

a=linspace(1000,3000,50);
fck=linspace(8,100,500);
p=0.01;
d=500;
b=250;
V=100;
q=100;
dg=16;
Es=200000;
Ec=10000*fck.^(1/3);
fy=500;
L=2.*a;
V_j=(q.*(L*10^-3))/2;
c_fck=d.*p.*(Es./Ec).*((1+((2.*Ec)./(p.*Es))).^(1/2)-1);
c_test=0.35+(fck-fck);
cforhold_fck=c_fck./d;


%% plot

subplot(1,2,2)
plot(fck,cforhold_fck)
hold on
plot(fck,c_test)
axis([ 8 100 0.2 0.5])

xlabel('f_c_k [MPa]')
ylabel('C/d [-]')
legend('Trykksonehyde','Antagelsen om at c=0.35d','location','northeast')
title('(b) Trykksonehyde ved varierende f_c_k','fontsize',16)
set(fig,'position',[0 0 1500 500])

print(fig,'beregning_c_forhold','-dpng','-r300')